********************************************************************************
* Program.: FieldSec.PRG
* Author..: Steve Zimmelman
* Date....: 11/22/1998
* Version.: FoxPro 2.6a DOS
********************************************************************************
*-- My Standard FoxPro Settings -**
Set Talk        Off
Set Exclusive   Off
Set Lock        Off
Set Safe        Off
Set Development On
Set Deleted     On
Set Bell        Off
Set Escape      Off
Set Scoreboard  Off
Set Status      Off
*
Close Data
Clear
Private cUserLevel
cUserLevel = ""
If ! Login()
   Return
Endif
Use Security In 0 Order Security
Use Names In 0 Order Name
Select Names
If (Upper(m.cUserLevel) = 'MASTER')
   On Key Label ALT+U Do F_Security ;
              With _CurObj, WOutPut()
Endif
*
Do Names.Spr
*
Close Data
On Key Label ALT+U
Return

Procedure F_Security
Parameter nObject, cScreen
Push Key Clear
Private nArea,cVar,lNew
nArea = Select()
If Empty(m.cScreen)
   cScreen = 'SCREEN'
Endif
If ! Used('Security')
   Use Security In 0 Order Security
Endif
Select Security
*-- Declare all field memvars private --*
For I = 1 To FCount()
   Private (Field(i))
EndFor

*-- Pad memvars to same length as fields --*
cScreen = Padr(Upper(m.cScreen),Len(Security.Screen))
cVar = Padr(ObjVar(m.nObject),Len(Security.VarName))

*-- Look for coressponding record in Security.dbf
*-- If one doesn't exist, add it
*
If ! Seek(m.cScreen+m.cVar)
   Scatter Memvar Blank
   Screen = m.cScreen
   VarName = m.cVar
   lNew = .T.
Else
   Scatter Memvar
   lNew = .F.
Endif

Do Security.SPR

Pop Key
Select (m.nArea)
Return

Function SecSave
*-- Called From OK button in Security.SPR --*
Private lSave,s,i

lSave = m.Master
*-- If m.Master is not checked, check for other
*-- levels.  If no other levels are checked, don't
*-- save the record.
If ! m.lSave
   For i = 1 To 9
      s = 'm.LEVEL'+Str(i,1)
      If Eval(m.s)
         lSave = .T.
         Exit
      Endif
   EndFor
Endif
Do Case
   Case ! m.lSave And ! m.lNew
      *-- nothing was checked,       --*
      *-- Reset Record To Be Reused. --*
      m.Screen  = ''
      m.VarName = ''
      Gather Memvar
   Case m.lSave
      If m.lNew
         If Seek(Space(15),'Security')
            Gather Memvar
         Else
            Insert Into Security From Memvar
         Endif
      Else
         Gather Memvar
      Endif
EndCase
Return .T.

Function ScrnWhen
Parameter cScrn
Private i
i=1
DO WHILE (Type('ObjVar(i)')='C')
   If ! FldRights(m.i,m.cScrn)
      Show Object (m.i) Disabled
   Endif
   i=i+1
ENDDO
Return .T.

Function FldRights
Parameter nObject,cScreen
Private Rtn,cEval,lCheck,s,i,cVar
Rtn = .T.
*
*-- Pad memvars to same length as fields --*
cScreen = Padr(Upper(m.cScreen),Len(Security.Screen))
cVar = Padr(ObjVar(m.nObject),Len(Security.VarName))
*
If Empty(m.cVar)
   Return .T.
Endif

If ! (Upper(m.cUserLevel) = 'MASTER')
   If Seek(m.cScreen+m.cVar,'Security')
      lCheck = Security.Master
      *
      *-- At least one level must be true
      *   to be a valid entry.
      *
      If ! m.lCheck
         For i = 1 To 9
            s = 'Security.LEVEL'+Str(i,1)
            If Eval(m.s)
               lCheck = .T.
               Exit
            Endif
         EndFor
      Endif
      If m.lCheck
         cEval = 'Security.'+m.cUserLevel
         Rtn = Eval(m.cEval)
      Endif
   Endif
Endif
Return (m.Rtn)


Function Login
*-- Very Simple Login --*
Private m.cName
cName = Space(30)
Define Window wLogin From 0,0 To 2,31 Double ;
   Title " Login Please " ;
   Color Scheme 7
Move Window wLogin Center
Activate Window wLogin
@ 0,0 Get m.cName Picture '@!'
Read
Release Window wLogin
Use Users Order 1
If Seek(AllTrim(m.cName))
   cUserLevel = Users.Sec_Level
Endif
Use In Users
Return (! Empty(m.cUserLevel))

*:EOF(FieldSec.PRG)
