*** CreateProcListing(<array to scan>)
** scans array and produces a temp file for each procedure encountered
** these files are added back into the main source file after the 
** object they are defined in
lparameters aScanArray

lSkipProcess = .F.
for nMInx = 1 to alen(aScanArray,1)
   * create a temporary file for this object
   hTFile = CreateTempFile()
   if hTFile = -1
      messagebox('Temp File Creation FAILED.',16)
      lSkipProcess = .T.
   endif
   
   if NOT lSkipProcess
      * create footnote info for this procedure
      nRtnVal = FootGen(hTFile,aScanArray[nMInx,2],aScanArray[nMInx,1])
      if nRtnVal = -1
         lSkipProcess = .T.
      endif
   endif
   
   if NOT lSkipProcess
      * create Topic Title and center it in display
      fputs(hTFile,'{\f4\fs20 \b ' + aScanArray[nMInx,1] + '\par }')
   
      * set formating back to plain
      fputs(hTFile,'{\pard\plain \li120 \f4\fs20 ')

      * extract actual procedure data and write to temp file
      nExtInx = 1
      nStartLine = atcline(aScanArray[nMInx,3],methods)
      if nStartLine > 0
         cCurLine = mline(methods,nStartLine + nExtInx)
         cCurLine = strtran(cCurLine,'\','\\')
         cCurLine = strtran(cCurLine,'{','\{')
         cCurLine = strtran(cCurLine,'}','\}')
         do while atc('ENDPROC',cCurLine,1) = 0
            fputs(hTFile,cCurLine + ' \par')
            nExtInx = nExtInx + 1
            cCurLine = mline(methods,nStartLine + nExtInx)
            cCurLine = strtran(cCurLine,'\','\\')
            cCurLine = strtran(cCurLine,'{','\{')
            cCurLine = strtran(cCurLine,'}','\}')
         enddo
         fputs(hTFile,'\par }')
         fputs(hTFile,'{\page }')
         fclose(hTFile)
      endif
   endif
endfor

return !lSkipProcess
