*** DfltVal(<property name>)
** checks properties field to see if user property has been changed
** from the default setting of .F.
function DfltVal
lparameters PropName

local cPropDflt
* check to see if it has an entry in the properties settings field
nPropVal = atcline(PropName,properties)
if nPropVal > 0
   * if it does, get the property default setting
   cPropValLine = mline(properties,nPropVal)
   cPropValLine = strtran(cPropValLine,'\','\\')
   nStripLen = len(PropName + ' = ')
   if nStripLen < len(cPropValLine)
      cPropDflt = alltrim(substr(cPropValLine,nStripLen))
   else
      cPropDflt = '??'
   endif
else
   * else set default value to .F. - the un-asigned default value
   cPropDflt = '.F.'
endif

return cPropDflt
