*** TOCScan(<help file to scan>,<scan for selector>)
** scans a help index file and lists included TOC files
lparameters cMasterHelp, cSelector
local ;
   cFileTestLine, ;
   cPre, ;
   cProgTestLine, ;
   hCntFile, ;
   hListFile, ;
   lOutFile, ;
   nFileInText, ;
   rtn_val, ;
   tmp_vl

if type('cMasterHelp') <> 'C' OR empty(cMasterHelp)
   cMasterHelp = alltrim(getfile('CNT'))
endif
if type('cSelector') <> 'C' OR empty(cSelector)
   cSelector = s_entr('TOC','TOC or INDEX reporting:')
endif
tmp_vl = messagebox('Create Output File?',35,'Update Request')
if tmp_vl = 6
   lOutFile = .T.
else
   lOutFile = .F.
   if tmp_vl = 2
      return 0
   endif
endif

do case
   case cSelector = 'TOC'
      cPre = ':include '

   case cSelector = 'INDEX'
      cPre = ':index '

endcase

hCntFile = fopen(cMasterHelp)
if hCntFile <> -1
   * scan current TOC for existance of this help file
   hListFile = fcreate(db_nam_ret(cMasterHelp) + '.txt.')
   if hListFile = -1
      lOutFile = .F.
   endif
   do while NOT feof(hCntFile)
      cFileTestLine = fgets(hCntFile)
      cProgTestLine = cPre
      nFileInText = atc(cProgTestLine,cFileTestLine)
      if nFileInText > 0
         ? cFileTestLine
         if lOutFile
            fputs(hListFile,cFileTestLine)
         endif
      endif
   enddo
   fclose(hCntFile)
   if lOutFile
      fclose(hListFile)
   endif
else
   messagebox('FAILED to open existing Main TOC File.',16)
   rtn_val = -1
endif


