*** TOCAdd(<main help file>,<file to add>,<type select>)
** creates entries in main help file to add additional help components
lparameters cMasterHelp, cAddHelp, cSelector
local ;
   cHelpFile, ;
   cHelpFileName, ;
   rtn_val

if type('cSelector') <> 'C' OR empty(cSelector)
   cSelector = 'TOC'
endif
* extract library name from file id string
cHelpFileName = SUBSTR(cMasterHelp,RAT('\',cMasterHelp) + 1)
IF RAT('.',cHelpFileName) <> 0
   cHelpFileName = SUBSTR(cHelpFileName,1,RAT('.',cHelpFileName) - 1)
ENDIF

cHelpFile = cHelpFileName + '.cnt'
rtn_val = 0

* conversion in case fox base directory is in long file name format
cXferFile = '"' + cMasterHelp + '"'

do case
   case cSelector = 'TOC'
      cPre = ':include '
      cPost = '.cnt'

   case cSelector = 'INDEX'
      cPre = ':index ' + cAddHelp + '='
      cPost = '.hlp'

endcase
* add file designator to foxhelp help contents file
hCntFile = fopen(cMasterHelp)
if hCntFile <> -1
   hOutFile = fcreate(cHelpFile)
   if hOutFile <> -1
      * scan current TOC for existance of this help file
      lExists = .F.
      do while NOT feof(hCntFile)
         cFileTestLine = fgets(hCntFile)
         cProgTestLine = cPre + cAddHelp + cPost
         nFileInText = atc(cProgTestLine,cFileTestLine)
         if nFileInText > 0
            lExists = .T.
         endif
      enddo
      fclose(hCntFile)
      if NOT lExists
         hCntFile = fopen(cMasterHelp)
         fputs(hOutFile,fgets(hCntFile))
         fputs(hOutFile,fgets(hCntFile))
         fputs(hOutFile,cPre + cAddHelp + cPost)
         do while NOT feof(hCntFile)
            fputs(hOutFile,fgets(hCntFile))
         enddo
         fclose(hCntFile)
         fclose(hOutFile)
         copy file &cHelpFile to &cXferFile
      else
         fclose(hOutFile)
      endif
   else
      messagebox('FAILED to create temporary TOC file.',16)
      rtn_val = -1
      fclose(hCntFile)
   endif
else
   messagebox('FAILED to open existing Main TOC File.',16)
   rtn_val = -1
endif

return rtn_val
